//+------------------------------------------------------------------+
//|                                    Bad_Vertical_Coloured_RSI.mq4 |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_separate_window

#property indicator_maximum 100
#property indicator_minimum 0

#property indicator_buffers 3

#property indicator_color1 Khaki
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red

//---- input parameters
extern int     RSIPeriod         =  14;
extern int     RSIPrice          =  0;
      
//---- buffers
double RSI[];

double Higher[];
double Lower[];

int init()
{
   SetIndexBuffer(0, RSI);

   SetIndexBuffer(1, Higher);
   SetIndexBuffer(2, Lower);

   SetIndexLabel(0, "RSI");
   SetIndexLabel(1, "RSI");
   SetIndexLabel(2, "RSI");
   
   SetIndexDrawBegin(0, RSIPeriod + 1);
   SetIndexDrawBegin(1, RSIPeriod + 1);
   SetIndexDrawBegin(2, RSIPeriod + 1);   
   
   IndicatorShortName("  RSI ( )");
   
   IndicatorDigits(2);

   return(0);
}

int start()
{
   int ToCount = Bars - IndicatorCounted();

   for (int cnt = ToCount - 1; cnt >= 0; cnt--)
   {
      RSI[cnt] = iRSI(NULL, 0, RSIPeriod, RSIPrice, cnt);
      Higher[cnt] = EMPTY_VALUE;
      Lower[cnt] = EMPTY_VALUE;
      
      if (RSI[cnt] > RSI[cnt + 1])
      {
         Higher[cnt] = RSI[cnt];
         Higher[cnt + 1] = RSI[cnt + 1];
      }
      else
      {
         Lower[cnt] = RSI[cnt];
         Lower[cnt + 1] = RSI[cnt + 1];
      }
   }
   
   return(0);
}